%define module_name	fglrx
%define module_version	3.7.0
%define module_release	alt1.17

%define kversion	2.4.22
%define krelease	alt17
%define flavour		std-smp

%define base_arch %(echo %{_target_cpu} | sed 's/i.86/i386/;s/athlon/i386/')

%define kgcc		gcc-2.96
%ifdef use_ccache
%define kcc ccache %kgcc
%else
%define kcc %kgcc
%endif

%define module_dir /lib/modules/%kversion-%flavour-%krelease/%module_name


Summary:	ATI video card drivers
Name:		kernel-modules-%{module_name}-%{flavour}
Version:	1.0.%{module_version}
Release:	%{module_release}
License:	Proprietary
Group:		System/Kernel and hardware

Packager:       Kernel Maintainer Team <kernel@packages.altlinux.org>

Patch1:		fglrx-3.2.8-agp-sis.patch
Patch2:		fglrx-3.2.5-agp-i875.patch
Patch3:		fglrx-3.2.8-via-agp2.patch
Patch4:		fglrx-3.2.8-nvidia-nforce.patch

ExclusiveOS:	Linux
URL:		http://www.schneider-digital.de/html/body_download_ati.html
BuildPreReq:    kernel-build-tools
BuildRequires:	%kgcc_package
BuildRequires:	modutils
BuildRequires:	perl
BuildRequires:	rpm >= 4.0.2-75
BuildRequires:  kernel-headers-%{flavour} = %{kversion}-%{krelease}
BuildRequires:  kernel-source-%{module_name}-%{module_version}

Provides:  kernel-modules-%module_name-%kversion-%flavour-%krelease = %version-%release
Conflicts: kernel-modules-%module_name-%kversion-%flavour-%krelease < %version-%release
Conflicts: kernel-modules-%module_name-%kversion-%flavour-%krelease > %version-%release

Prereq:		coreutils
Prereq:		modutils
Prereq:         kernel-image-%{flavour} = %{kversion}-%{krelease}
Requires(postun): kernel-image-%flavour = %kversion-%krelease
ExclusiveArch:	%{ix86}

%description
Drivers for Linux Fire GL X1/Z1/E1/8800/8700/9000/9700/9800 RADEON 
for XFree86 Version X4.3.0.

%prep

rm -rf kernel-source-%{module_name}-%{module_version}                                                                        
                                                                                                         
tar -jxvf %kernel_src/kernel-source-%{module_name}-%{module_version}.tar.bz2
                                                                                                         
%setup -D -T -n kernel-source-%{module_name}-%{module_version}
%patch1 -p1
%patch2 -p1
%patch3 -p1
%patch4 -p1

%build
if grep -qs '#define.*CONFIG_SMP.*1' %_includedir/linux-%{kversion}-%{flavour}/include/linux/autoconf.h ; then
	def_smp="-D__SMP__"
else
	def_smp=""
fi

%define fglrx_gcc %kcc -Wall -Wwrite-strings -Wpointer-arith -Wcast-align -Wstrict-prototypes -Wpointer-arith -O2  -D__KERNEL__ -DMODULE -DMODVERSIONS -fomit-frame-pointer -DATI_AGP_HOOK -DATI -DFGL -DFGL_CUSTOM_MODULE -D__AGP__ -DPAGE_ATTR_FIX=1 -I. -I%_includedir/linux-%{kversion}-%{flavour}/include -include %_includedir/linux-%{kversion}-%{flavour}/include/linux/modversions.h $def_smp

%fglrx_gcc -c agpgart_be.c -o agpgart_be.o
%fglrx_gcc -c nvidia-agp.c -o nvidia-agp.o
%fglrx_gcc -c agp3.c -o agp3.o
%fglrx_gcc -c i7505-agp.c -o i7505-agp.o
%fglrx_gcc -c firegl_public.c -o firegl_public.o
ld -r firegl_public.o agpgart_be.o agp3.o i7505-agp.o nvidia-agp.o \
    libfglrx_ip.a.GCC%__gcc_version_major -o fglrx.o


%install
mkdir -p $RPM_BUILD_ROOT/%{module_dir}
install -p -m644 fglrx.o $RPM_BUILD_ROOT/%{module_dir}

%post
/sbin/depmod -a -F /boot/System.map-%{kversion}-%{flavour}-%{krelease} \
    %{kversion}-%{flavour}-%{krelease}

%postun
[ ! -f /boot/System.map-%kversion-%flavour-%krelease ] || \
/sbin/depmod -a -F /boot/System.map-%{kversion}-%{flavour}-%{krelease} \
    %{kversion}-%{flavour}-%{krelease}

%files
%defattr(644,root,root,755)
%module_dir

%changelog
* Sun Jan 04 2004 Sergey Vlasov <vsu@altlinux.ru> 1.0.3.7.0-alt1.17
- Version 3.7.0.
- Fixed SMP build options (-D__SMP__ is required for SMP kernels).
- Fixed PAGE_ATTR_FIX typo in compilation options.

* Fri Nov 28 2003 Sergey Vlasov <vsu@altlinux.ru> 1.0.3.2.8-alt3.17
- Added Provides/Conflicts to make sure that only one version of the package
  can be installed for each kernel version.

* Tue Nov 18 2003 Sergey Vlasov <vsu@altlinux.ru> 1.0.3.2.8-alt2.17
- Fixed spec file name.
- Avoid %%postun failure when this package is removed after
  kernel-image-%%flavour (currently rpm cannot prevent this).
- Added Patch4: fglrx-3.2.8-nvidia-nforce.patch: fixed nForce AGP support.

* Sun Oct 12 2003 Sergey Vlasov <vsu@altlinux.ru> 1.0.3.2.8-alt1.17
- new version (3.2.8).
- updated Patch1 (some SiS support was added in upstream, only SiS 745 remains
  unknown).
- fixed compile flags.
- Patch3: fixed AGP 2.0 support for VIA KT400 and P4X333.

* Mon Sep 29 2003 Sergey Vlasov <vsu@altlinux.ru> 1.0.3.2.5-alt16.17
- Patch2: fixed Intel 875P chipset support (it does not have integrated
  graphics capability).

* Fri Sep 26 2003 Sergey Vlasov <vsu@altlinux.ru> 1.0.3.2.5-alt15.17
- replaced %%{_usrsrc}/kernel/sources with %%kernel_src
- Patch1: added new SiS host bridge IDs to the builtin AGP support (from
  mainstream kernel)

* Mon Sep 08 2003 Anton Farygin <rider@altlinux.ru> 1.0.3.2.5-alt14.17
- new version (3.2.5)

* Wed Sep 03 2003 Rider <rider@altlinux.ru> 1.0.2.9.12-alt14.17
- replace /usr/include to _includedir macro

* Tue Aug 26 2003 Peter Novodvorsky <nidd@altlinux.com> 1.0.2.9.12-alt13
- rebuilt with 2.4.21rel-alt14

* Fri Aug 15 2003 Peter Novodvorsky <nidd@altlinux.com> 1.0.2.9.12-alt12
- rebuilt with 2.4.21rel-alt13

* Wed Aug 13 2003 Peter Novodvorsky <nidd@altlinux.com> 1.0.2.9.12-alt11
- rebuilt with 2.4.21rel-alt12

* Tue Aug 12 2003 Peter Novodvorsky <nidd@altlinux.com> 1.0.2.9.12-alt10
- rebuilt with 2.4.21rel-alt11

* Mon Aug 11 2003 Peter Novodvorsky <nidd@altlinux.com> 1.0.2.9.12-alt9
- rebuilt with 2.4.21rel-alt10

* Thu Aug 07 2003 Peter Novodvorsky <nidd@altlinux.com> 1.0.2.9.12-alt8
- rebuilt with 2.4.21rel-alt9

* Wed Aug 06 2003 Peter Novodvorsky <nidd@altlinux.com> 1.0.2.9.12-alt7
- rebuilt with 2.4.21rel-alt8

* Wed Jul 30 2003 Peter Novodvorsky <nidd@altlinux.com> 1.0.2.9.12-alt6
- rebuilt with 2.4.21rel-alt7

* Thu Jul 17 2003 Peter Novodvorsky <nidd@altlinux.com> 1.0.2.9.12-alt5
- rebuilt with 2.4.21rel-alt6

* Wed Jul 16 2003 Peter Novodvorsky <nidd@altlinux.com> 1.0.2.9.12-alt4
- rebuilt with 2.4.21rel-alt5

* Tue Jul 08 2003 Peter Novodvorsky <nidd@altlinux.com> 1.0.2.9.12-alt3
- added -include /usr/include/linux-%{kversion}-%{flavour}/include/linux/modversions.h
  now it actually WORKS!

* Sat Jun 21 2003 Peter Novodvorsky <nidd@altlinux.com> 1.0.2.9.12-alt2
- rebuilt with 2.4.21rel kernel

* Thu Jun 05 2003 Peter Novodvorsky <nidd@altlinux.com> 1.0.2.9.12-alt1
- initial version.

